OsmoPCU - Bug #2406

CS-PAGING not implemented
07/29/2017 09:06 AM - laforge

Status: Resolved Start date: 07/29/2017
Priority: Low Due date:

Assignee: laforge % Done: 100%
Category:

Target version:

Spec Reference:

Description

BSSGP PAGING CS is used to deliver a circuit-switched paging request to a MS while it is engaged in transferring GPRS data. The
related paging request is not sent via Broadcast/PCH, but via PACCH to that MS.

Related issues:

Related to OsmoPCU - Bug #3927: Missing PCU_Tests.ttcn Paging tests Resolved 04/15/2019
Related to OsmoPCU - Bug #2403: PS-PAGING and CS-PAGING not implemented on PT... Resolved 07/29/2017
Related to OsmoBSC - Feature #4485: osmo-bsc: We should be announcing NMO 1 i... Rejected 04/06/2020
History

#1 - 10/29/2017 06:51 PM - laforge

- Priority changed from Normal to Low

#2 - 10/02/2018 03:43 PM - laforge

#3 - 10/17/2018 10:24 AM - laforge

- Assignee changed from laforge to msuraev

#4 - 04/15/2019 07:52 AM - laforge

- Assignee changed from msuraev to lynxis

#5 - 09/10/2019 11:55 AM - laforge

- Assignee changed from lynxis to osmith

Please note this is mostly relevant with other core networks than osmocom. In osmcoom, the MSC pages the BSC and the BSC pages the BTS,
which then passes it to the PCU for transmission. This works.

However, when using a non-osmocom core with Gs interface between MSC and SGSN for paging coordination, the SGSN will likely send us
CS-PAGING and we have to implement it in the PCU for interoperability.

#6 - 09/24/2019 12:22 PM - osmith

- Status changed from New to In Progress

#7 - 12/09/2019 07:26 PM - pespin
- Related to Bug #3927: Missing PCU_Tests.ttcn Paging tests added

#8 - 12/09/2019 07:46 PM - pespin

While developing some TTCN3 PCU tests (#3927) | also tried to understand better this scenario. Some references | could fine:
TS 23.060 sec 6.3.3 CS Paging (A/Gb mode)

TS 48-008 sec 3.1.10 Paging

TS 24.008 sec 4.7.9 Paging procedure

TS 44.018 sec 3.2.2.2 paging

TS 48.018 sec 5.2.4, 7.1

PAGING-PS: TS 48.018 10.3.1

PAGING-CS: TS 48.018 10.3.2
https://projects.osmocom.org/issues/3927

Specially important are the last 2, where the SGSN->PCU PDUs requesting the paging are described.

As far as | understand, we already implement paging (not sure if correctly) in the SGSN: it uses libosmocore's bssgp_tx_paging().
In libosmocore, we also have a symbol which afaiu we should use in osmo-pcu and which | think is not yet use by anybody:

gprs_bssgp_bss.c:
/* Parse a single GMM-PAGING.req to a given NSEI/NS-BVCI */
int bssgp_rx_paging(struct bssgp_paging_info *pinfo,

struct msgb *msg)

It seems PS-PAGING is already supported by osmo-pcu, while CS-PAGING is not:

case BSSGP_PDUT_PAGING_PS:
gprs_bssgp_pcu_rx_paging_ps (msg, tp);

case BSSGP_PDUT_PAGING_CS:
case BSSGP_PDUT_FLUSH_LL:
case BSSGP_PDUT_SGSN_INVOKE_TRACE:
LOGP (DBSSGP, LOGL_INFO, "Rx BSSGP BVCI=%d (SIGN) PDU type %s not implemented\n",
bvci, bssgp_pdu_str (pdu_type));
break;

If | understand correctly, what's missing here is to do something similar to what we do when PCU receives a struct gsm_pcu_if_pag_req with type
PCU_IF_MSG_PAG_REQ on pcu_rx_pag_req() from BTS. That path is already covered by PCU_Tests_ RAW.TC_paging_cs_from_bts, where a
DL_PACKET_PAGING_REQUEST is sent over PACCH. The only difference in this scenario is that the PAGING_REQUEST must be retriggered on
reception of the CS-PAGING message from SGSN in gprs_bssgp_pcu.cpp.

So mainly calling libosmocore's bssgp_rx_paging() and then calling similar to what pcu_rx_pag_req() does:

return BTS::main_bts () ->add_paging (pag_reg->chan_needed,
pag_reg->identity_1v);

#9 - 12/10/2019 05:25 PM - pespin
- Related to Bug #2403: PS-PAGING and CS-PAGING not implemented on PTP-BVCI added

#10 - 12/10/2019 07:17 PM - pespin
- Status changed from In Progress to Feedback

- % Done changed from 0 to 90

Done so far:
remote: https://gerrit.osmocom.org/c/osmo-pcu/+/16536 Allow Gb PAGING-PS without P-TMSI
remote: https:/gerrit.osmocom.org/c/osmo-pcu/+/16537 Support Gb PAGING-CS

Can be tested with TTCN3 PCU test TC_paging_cs_from_sgsn.

#11 - 12/23/2019 01:53 PM - pespin

- Assignee changed from osmith to pespin

Testing is done here:
https://gerrit.osmocom.org/c/osmo-ttcn3-hacks/+/16528 pcu: Introduce tests for CS and PS paging from SGSN/Gb

#12 - 01/21/2020 04:14 PM - pespin
- Status changed from Feedback to Resolved

- % Done changed from 90 to 100

#13 - 04/06/2020 12:17 PM - fixeria

- Status changed from Resolved to Feedback

BTW, there is BSS_PAGING_COORDINATION in SI13 / GPRS Cell Options IE (see 3GPP TS 44.060, table 12.24.2):

This field indicates the network support of CS paging co-ordination in packet transfer mode
during network mode of operation II and III. [...] It is coded as follows:

0 The cell does not support Circuit-Switched paging coordination
https://gerrit.osmocom.org/c/osmo-pcu/+/16536
https://gerrit.osmocom.org/c/osmo-pcu/+/16537
1 The cell supports Circuit-Switched paging coordination
OsmoBSC currently hard-codes this option to 0. Should we make it configurable?
As per section 6.1.3 "Paging initiation using PACCH", "if such indication is received, a mobile station in packet transfer mode shall expect the paging

messages to be received on the PACCH". So does it mean that otherwise (if BSS_PAGING_COORDINATION is set to 0) the MS would ignore our
paging messages?

#14 - 04/06/2020 07:39 PM - fixeria
- Related to Feature #4485: osmo-bsc: We should be announcing NMO | instead of NMO Il added

#15 - 06/21/2020 01:42 PM - laforge
- Status changed from Feedback to In Progress

- Assignee changed from pespin to laforge

fixeria wrote:

BTW, there is BSS_PAGING_COORDINATION in SI13 / GPRS Cell Options IE (see 3GPP TS 44.060, table 12.24.2):

nice catch. I'm adding related code in https://gerrit.osmocom.org/c/libosmocore/+/18934 and https:/gerrit.osmocom.org/c/osmo-bsc/+/18936

#16 - 06/21/2020 05:46 PM - laforge

- Status changed from In Progress to Resolved

laforge wrote:
fixeria wrote:

BTW, there is BSS_PAGING_COORDINATION in SI13 / GPRS Cell Options IE (see 3GPP TS 44.060, table 12.24.2):

nice catch. I'm adding related code in https://gerrit.osmocom.org/c/libosmocore/+/18934 and https://gerrit.osmocom.org/c/osmo-bsc/+/18936

patch merged.
